package com.iformall.controller.mem;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxCUserTags;
import com.iformall.service.WxCUserTagsService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxCUserTags")
public class WxCUserTagsController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCUserTagsService wxCUserTagsService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "会员首页-标签-列表")
    public ResultData list(@ModelAttribute WxCUserTags wxCUserTags, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCUserTagsController::list");
        if (null == wxCUserTags) wxCUserTags = new WxCUserTags();
        final PageInfo<WxCUserTags> page = wxCUserTagsService.listAsPage(wxCUserTags, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "会员首页-标签-新增")
    public ResultData add(@RequestBody WxCUserTags wxCUserTags) {
        logger.debug("[" + getIpAddr() + "] WxCUserTagsController::add");
        //Assert.notNull(wxCUserTags.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxCUserTagsService.saveOrUpdate(wxCUserTags);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "会员首页-标签-更新")
    public ResultData update(@RequestBody WxCUserTags wxCUserTags) {
        logger.debug("[" + getIpAddr() + "] WxCUserTagsController::update");
        wxCUserTagsService.saveOrUpdate(wxCUserTags);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "会员首页-标签-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCUserTagsController::delete");
        wxCUserTagsService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "会员首页-标签-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCUserTagsController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxCUserTagsService.getById(id));
    }


}
